var jq_txgz_avatar = jQuery.noConflict(true);

var embedwidth = 0;
var embedheight = 0;
var embedsrc = '';

for (var i = 0; i < document.getElementsByTagName('embed').length; i++) {
    var embed = document.getElementsByTagName('embed')[i];
    if (embed.getAttribute("name") == 'mycamera') {
        embedwidth = embed.width;
        embedheight = embed.height;
        embedsrc = embed.src;
    }
}

var dwidth = embedwidth;
var dheight = embedheight;
var avatarform;

if (isCanvasSupported()) {
    replaceAvatarSection(document.getElementById('avatardesigner'));
    avatarform = jq_txgz_avatar('#avatardesigner').closest('form').get(0);
    jq_txgz_avatar('#avatardesigner').show();
    jq_txgz_avatar('#avatardesigner').width(dwidth);
    jq_txgz_avatar('#avatardesigner').height(dheight);
    jq_txgz_avatar('#avatarfileselector').height(dheight - 5);
    jq_txgz_avatar('#widgetparent').width(dwidth - 150);
    jq_txgz_avatar('#widgetparent').height(dheight);
    jq_txgz_avatar('#selector').width(150);
    jq_txgz_avatar('#selector').height(150);
    // http://stackoverflow.com/questions/6908094/rectangle-on-html5-canvas-is-stretched
    jq_txgz_avatar('#avatarcanvas').attr('width', (dwidth - 150));
    jq_txgz_avatar('#avatarcanvas').attr('height', dheight);
    jq_txgz_avatar('#avatardisplaycanvas').attr('width', dwidth);
    jq_txgz_avatar('#avatardisplaycanvas').attr('height', dheight);
    document.write("<style>.imgl img { max-width: " + (dwidth / 5 - 15) + "px; }</style>");
    document.getElementById('upload_src').value = embedsrc.replace('images/camera.swf?inajax=1', 'index.php?m=user&a=uploadavatar');
    avatarform.target = 'uploadframe';
    avatarform.enctype = 'multipart/form-data';
}

jq_txgz_avatar(document).ready(function () {
    jq_txgz_avatar("#selector")
        .draggable({
            containment: "parent",
            drag: function (event, ui) { refreshAvatarCanvas(ui.position); },
            stop: function () { forceSelectorInsideAvatar(); }
        })
        .resizable({
            containment: "parent",
            handles: { 
                'ne': '#negrip',
                'se': '#segrip',
                'sw': '#swgrip',
                'nw': '#nwgrip',
                'n': '#ngrip',
                'e': '#egrip',
                's': '#sgrip',
                'w': '#wgrip'
            },
            resize: function (event, ui) { refreshAvatarCanvas(ui.position); },
            stop: function () { forceSelectorInsideAvatar(); }
        })
        .hover(
            function () { jq_txgz_avatar(this).css({ "border-color": "red" }); },
            function () { jq_txgz_avatar(this).css({ "border-color": "rgba(255, 0, 0, 0.6)" }); }
        );
    jq_txgz_avatar("#slider").slider({
        min: 0,
        max: 100,
        value: 50,
        slide: function(event, ui) {
            forceSelectorInsideAvatar();
        }
    });
    jq_txgz_avatar("#slider").append("<div style='position: absolute; top: -2px; left: 0px; width: 3px; height: 6px; background-color: black;'>&nbsp;</div>" );
    jq_txgz_avatar("#slider").append("<div style='position: absolute; top: -2px; left: 50px; width: 3px; height: 6px; background-color: black;'>&nbsp;</div>" );
    jq_txgz_avatar("#slider").append("<div style='position: absolute; top: -2px; left: 100px; width: 3px; height: 6px; background-color: black;'>&nbsp;</div>");
    jq_txgz_avatar('#avatarimage').load(function () {
        forceSelectorInsideAvatar();
    });
    jq_txgz_avatar('#uploadframe').load(function () {
        uploadAvatarDone();
    });
    jq_txgz_avatar('#rectframe').load(function () {
        rectAvatarDone();
    });
});

function selectLocalAvatarFileDone() {
    var avatarfile = document.getElementById('avatarfile');
    var file = avatarfile.files[0];
    var fr = new FileReader();
    fr.onload = function () {
        document.getElementById('avatarimage').src = fr.result;
    };
    fr.readAsDataURL(file);
    // http://stackoverflow.com/questions/1703228/how-to-clear-file-input-with-javascript
    try {
        var av = document.getElementById('avatarfile');
        av.value = '';
        if (av.value) {
            av.type = "text";
            av.type = "file";
        }
    } catch (e) { }
    jq_txgz_avatar('#avatarfileselector').hide();
    jq_txgz_avatar('#avatardisplayer').hide();
    jq_txgz_avatar('#avataradjuster').show();
    jq_txgz_avatar('#selector').css('left', Math.floor((dwidth - 300) / 2));
    jq_txgz_avatar('#selector').css('top', Math.floor((dheight - 150) / 2));
    jq_txgz_avatar('#selector').width(150);
    jq_txgz_avatar('#selector').height(150);
    jq_txgz_avatar("#slider").slider('value', 50);
}

function uploadAvatarDone() {
    var iframe = document.getElementById('uploadframe');
    var iframeDocument = iframe.contentDocument || iframe.contentWindow.document;
    if (!iframeDocument.body) return;
    var imageSrc = iframeDocument.body.innerHTML;
    if (!imageSrc) return;

    if (imageSrc.indexOf('http') !== 0) { // server returns error message
        if (imageSrc != -4) { // ie11 bug?: called twice, the value in the second time is -4
            alert(imageSrc);
        }
        return;
    }
    // http://stackoverflow.com/questions/1703228/how-to-clear-file-input-with-javascript
    try {
        var av = document.getElementById('avatarfile');
        av.value = '';
        if(av.value){
            av.type = "text";
            av.type = "file";
        }
    } catch(e){}
    jq_txgz_avatar('#avatarfileselector').hide();
    jq_txgz_avatar('#avatardisplayer').hide();
    jq_txgz_avatar('#avataradjuster').show();
    jq_txgz_avatar('#selector').css('left', Math.floor((dwidth-300)/2));
    jq_txgz_avatar('#selector').css('top', Math.floor((dheight-150)/2));
    jq_txgz_avatar('#selector').width(150);
    jq_txgz_avatar('#selector').height(150);
    // http://stackoverflow.com/questions/1077041/refresh-image-with-a-new-one-at-the-same-url
    imageSrc += "#" + (new Date()); // some sites do not like query string for image url, therefore use # instead of ?
    document.getElementById('avatarimage').src = imageSrc;
    jq_txgz_avatar("#slider").slider('value', 50);
}

function showAvatarFileSelector() {
    document.getElementById('avatarimage').src = null;
    clearAvatar();
    document.getElementById('avataradjuster').style.display = 'none'; 
    document.getElementById('avatarfileselector').style.display = 'block';
}

function getAvatarDimension() {
    var factor = jq_txgz_avatar('#slider').slider('option', 'value');
    var cw = jq_txgz_avatar('#widgetparent').width();
    var ch = jq_txgz_avatar('#widgetparent').height();
    var iw = jq_txgz_avatar('#avatarimage').width();
    var ih = jq_txgz_avatar('#avatarimage').height();
    var minw = 48;
    var minh = 48;
    var midw = Math.min(Math.max(iw, 48), cw);
    var midh = Math.min(Math.max(ih, 48), ch);
    var maxw = Math.max(Math.max(iw, 48), cw);
    var maxh = Math.max(Math.max(ih, 48), ch);
    var minr = Math.max(minw/iw, minh/ih);
    var midr = Math.max(midw/iw, midh/ih);
    var maxr = Math.max(maxw/iw, maxh/ih);
    if (factor<=50) {
        r = (minr * (50-factor) + midr * factor)/50;
    }
    else {
        r = (midr * (100-factor) + maxr * (factor-50))/50;
    }
    var aw = r*iw;
    var ah = r*ih;
    var al = (cw-aw)/2;
    var at = (ch-ah)/2;
    var sd = getSelectorDimention();
    if (aw>cw) al = (cw-aw)/(cw-sd.width)*sd.left;
    if (ah>ch) at = (ch-ah)/(ch-sd.height)*sd.top;
    return { left: Math.floor(al), top: Math.floor(at), width: Math.floor(aw), height: Math.floor(ah) };
}

function clearAvatar() {
    var canvas = document.getElementById('avatarcanvas');
    var cw = canvas.width;
    var ch = canvas.height;
    var ctx = canvas.getContext('2d');
    ctx.clearRect(0, 0, cw, ch);
}

function refreshAvatarCanvas(uiposition) { 
    var canvas = document.getElementById('avatarcanvas');
    var cw = canvas.width;
    var ch = canvas.height;
    var ctx = canvas.getContext('2d');
    ctx.clearRect(0, 0, cw, ch);
    var ad = getAvatarDimension();
    var iw = jq_txgz_avatar('#avatarimage').width();
    var ih = jq_txgz_avatar('#avatarimage').height();
    var img = document.getElementById('avatarimage');
    ctx.drawImage(img, 0,0, iw, ih, ad.left, ad.top, ad.width, ad.height);
    var sd = getSelectorDimention();
    // http://stackoverflow.com/questions/6258834/jquery-ui-draggable-event-timing
    if (uiposition) {
        sd.left = uiposition.left;
        sd.top = uiposition.top;
    }
    ctx.fillStyle="rgba(0,0,0,0.6)";
    ctx.fillRect(0, 0, cw, sd.top);
    ctx.fillRect(sd.left+sd.width, sd.top, cw-sd.left-sd.width, ch-sd.top);
    ctx.fillRect(0, sd.top+sd.height, sd.left+sd.width, ch-sd.top-sd.height);
    ctx.fillRect(0, sd.top, sd.left, sd.height);
}

function getSelectorDimention() {
    var sl = Math.ceil(jq_txgz_avatar('#selector').position().left);
    var st = Math.ceil(jq_txgz_avatar('#selector').position().top);
    var sw = jq_txgz_avatar('#selector').width();
    var sh = jq_txgz_avatar('#selector').height();
    return { left: sl, top: st, width: sw, height: sh };
}

function forceSelectorInsideAvatar() {
    var sd = getSelectorDimention();
    var ad = getAvatarDimension();
    if (sd.width>ad.width) jq_txgz_avatar('#selector').width(ad.width);
    if (sd.height>ad.height) jq_txgz_avatar('#selector').height(ad.height);
    sd = getSelectorDimention();
    if (sd.left<ad.left) jq_txgz_avatar('#selector').css('left', ad.left);
    if (sd.top<ad.top) jq_txgz_avatar('#selector').css('top', ad.top);
    if (sd.left+sd.width>ad.left+ad.width) jq_txgz_avatar('#selector').css('left', ad.left+ad.width-sd.width);
    if (sd.top+sd.height>ad.top+ad.height) jq_txgz_avatar('#selector').css('top', ad.top+ad.height-sd.height);     
    refreshAvatarCanvas();
}

function saveAvatar() {
    var img = document.getElementById('avatarimage');
    var sd = getSelectorDimention();
    var ad = getAvatarDimension();
    var rl = (sd.left-ad.left)/ad.width;
    var rt = (sd.top-ad.top)/ad.height;
    var rw = sd.width/ad.width;
    var rh = sd.height/ad.height;
    var iw = jq_txgz_avatar('#avatarimage').width();
    var ih = jq_txgz_avatar('#avatarimage').height();
    var sl = rl*iw;
    var st = rt*ih;
    var sw = rw*iw;
    var sh = rh*ih;
    var tw = sw;
    var th = sh;
    if (sw>200 || sh>250) {
        var r = Math.max(sw/200, sh/250);
        tw = Math.floor(sw/r);
        th = Math.floor(sh/r);
    }          
    var canvas = document.createElement('canvas');
    canvas.width = tw;
    canvas.height = th;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, sl, st, sw, sh, 0, 0, tw, th);
    var dataURL = canvas.toDataURL("image/jpeg");
    jq_txgz_avatar('#avatar1').val(flashdata_encode(atob(dataURL.substr(dataURL.indexOf(",") + 1))));

    var tw = sw;
    var th = sh;
    if (sw>120 || sh>120) {
        var r = Math.max(sw/120, sh/120);
        tw = Math.floor(sw/r);
        th = Math.floor(sh/r);
    }     
    var canvas = document.createElement('canvas');
    canvas.width = tw;
    canvas.height = th;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, sl, st, sw, sh, 0, 0, tw, th);
    var dataURL = canvas.toDataURL("image/jpeg");
    jq_txgz_avatar('#avatar2').val(flashdata_encode(atob(dataURL.substr(dataURL.indexOf(",") + 1))));

    var mwh = Math.min(sw, sh);
    if (sw>mwh) {
        sl += Math.floor((sw-mwh)/2);
        sw = mwh;
    }
    if (sh>mwh) {
        st += Math.floor((sh-mwh)/2);
        sh = mwh;
    }
    var tw = 48;
    var th = 48;
    var canvas = document.createElement('canvas');
    canvas.width = tw;
    canvas.height = th;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, sl, st, sw, sh, 0, 0, tw, th);
    var dataURL = canvas.toDataURL("image/jpeg");
    jq_txgz_avatar('#avatar3').val(flashdata_encode(atob(dataURL.substr(dataURL.indexOf(",") + 1))));

    avatarform.action = document.getElementById('upload_src').value.replace('&a=uploadavatar', '&a=rectavatar');
    avatarform.target = 'rectframe';
}

function refreshAvatarCanvasForDisplay() {
    var img = document.getElementById('avatarimage');
    var canvas = document.getElementById('avatardisplaycanvas');
    var ctx = canvas.getContext("2d");
    var sd = getSelectorDimention();
    var ad = getAvatarDimension();
    var rl = (sd.left-ad.left)/ad.width;
    var rt = (sd.top-ad.top)/ad.height;
    var rw = sd.width/ad.width;
    var rh = sd.height/ad.height;
    var iw = jq_txgz_avatar('#avatarimage').width();
    var ih = jq_txgz_avatar('#avatarimage').height();
    var sl = rl*iw;
    var st = rt*ih;
    var sw = rw*iw;
    var sh = rh*ih;
    var tw = sw;
    var th = sh;
    if (sw>200 || sh>250) {
        var r = Math.max(sw/200, sh/250);
        tw = Math.floor(sw/r);
        th = Math.floor(sh/r);
    }  
    var ctl = 10;
    var ctt = 10;
    ctx.drawImage(img, sl, st, sw, sh, ctl, ctt, tw, th);
    ctl += 10 + tw;

    var tw = sw;
    var th = sh;
    if (sw>120 || sh>120) {
        var r = Math.max(sw/120, sh/120);
        tw = Math.floor(sw/r);
        th = Math.floor(sh/r);
    }     
    ctx.drawImage(img, sl, st, sw, sh, ctl, ctt, tw, th);
    ctl += 10 + tw;

    var tw = 48;
    var th = 48;
    var mwh = Math.min(sw, sh);
    if (sw>mwh) {
        sl += Math.floor((sw-mwh)/2);
        sw = mwh;
    }
    if (sh>mwh) {
        st += Math.floor((sh-mwh)/2);
        sh = mwh;
    }
    ctx.drawImage(img, sl, st, sw, sh, ctl, ctt, tw, th);

    ctx.fillStyle = "black";
    ctx.font = "bold 16px Arial";
    ctx.fillText(upload_succeed, dwidth - 140, 180);
    ctx.fillStyle = "grey";
    ctx.font = "bold 14px Arial";
    ctx.fillText(three_avatars, dwidth - 180, 205);
}

function rectAvatarDone() {
    var iframe = document.getElementById('rectframe'); 
    var iframeDocument = iframe.contentDocument || iframe.contentWindow.document;
    var faces = iframeDocument.getElementsByTagName("face");
    if (faces.length == 0) return;
    var res = faces[0].getAttribute("success");
    if (res == 1) {
        jq_txgz_avatar('#avatardisplayer').show();
        refreshAvatarCanvasForDisplay();
        jq_txgz_avatar('#avataradjuster').hide();
        jq_txgz_avatar('#avatarfileselector').hide();            
    }
    else {
        alert(upload_error + ": " + res);
    }
}

function flashdata_encode(s) {
    var r = '';
    var l = s.length;
    for (var i = 0; i < l; i++) {
        var k = s[i].charCodeAt(0);
        var k1 = k >> 4;
        var k2 = k - (k1 << 4);
        k1 += 48;
        if (k1 > 57) k1 += 7;
        k2 += 48;
        if (k2 > 57) k2 += 7;
        r += String.fromCharCode(k1, k2);
    }
    return r;
}

// copied from template/default/home/editor_image_menu.htm
function switchImagebutton(btn) {
    switchButton(btn, 'image');
    doane();
}

function picView(albumid, listid) {
    if (albumid == 'none') {
        $(listid).innerHTML = '';
    } else {
        ajaxget('home.php?mod=misc&ac=ajax&op=album&id=' + albumid + '&ajaxdiv=albumpic_body', listid);
    }
}

function insertImage(url) {
    document.getElementById('album_pic_url').value = url;
    avatarform.action = 'plugin.php?id=txgz_avatar:avatar';
    avatarform.submit();
}

function replaceAvatarSection(html5section) {
    html5section.parentNode.removeChild(html5section);
    for (var i = 0; i < document.getElementsByTagName('embed').length; i++) {
        var embed = document.getElementsByTagName('embed')[i];
        if (embed.getAttribute("name") == 'mycamera') {
            embed.parentNode.replaceChild(html5section, embed);
        }
    }
}

//http://stackoverflow.com/questions/2745432/best-way-to-detect-that-html5-canvas-is-not-supported
function isCanvasSupported() {
    var elem = document.createElement('canvas');
    return !!(elem.getContext && elem.getContext('2d'));
}